<?php

/*
 * Copyright (C) 2014, NoccyLabs
 * 
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>
 */

namespace NoccyLabs\Gpio\Device\Display;

use NoccyLabs\Gpio\Device\Device;

class Pcd8544Device extends Device
{
    protected function configure()
    {
        $this
            ->setName("pcd8544")
            ->setDescription("Philips PCD8544 LCD Display Driver")
            ->addLogicalPin(0, "dc", "data/command")
            ->addLogicalPin(1, "sce", "chip select")
            ->addLogicalPin(2, "scl", "clock")
            ->addLogicalPin(3, "sda", "data")
            ->addLogicalPin(4, "res", "reset")
            ->addLogicalPin(9, "bl", "backlight")
            ;
    }
    
    protected function startup()
    {
        
    }
    
    public function setBacklightState($state)
    {
        $this->bl->setValue((bool)$state);
    }
}
