<?php

/*
 * Copyright (C) 2014, NoccyLabs
 * 
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>
 */

namespace NoccyLabs\Gpio\Exception\Handler;

use NoccyLabs\Gpio\Exception\GpioException;

class ConsoleExceptionHandler
{
    protected $last;
    
    public function register()
    {
        $this->last = set_exception_handler( array($this, "onException") );
    }
    
    public function onException(Exception $exception)
    {
        if (is_callable($this->last)) {
            call_user_func($this->last, $exception);
        }
        if ($exception instanceof GpioException) {
            $pin = $exception->getPin();
            if ($pin) {
                $pin->dumpState();
            }
        } 
    }


}
